'''
Email Concentrator class
@author: Peeter Jyrviste
'''
import AsynchronousDeliveryAgent, PrologParser, GraphParser
import getpass

def singleton(object, instantiated=[]):
    "Raise an exception if an object of this class has been instantiated before."
    assert object.__class__ not in instantiated, \
        "%s is a Singleton class but is already instantiated" % object.__class__
    instantiated.append(object.__class__)

class EmailConcentrator:
    "A singleton class to create an email concentrator."
    def __init__(self):
        singleton(self)
        login = raw_input('Login: ')
        password = getpass.getpass()
        async = AsynchronousDeliveryAgent.AsynchronousDeliveryAgent('imap.gmail.com', 993, login, password, 'test.mbox')
        async.fetchMail()
        prolog = PrologParser.PrologParser('test.mbox', 'test.pl')
        prolog.displayMail()
        egraph = GraphParser.GraphParser('test.mbox', 'egraph.txt')
        egraph.pickleGraph()

if __name__ == '__main__':
    EmailConcentrator()
    raw_input('Press [ENTER] to terminate...')
