'''
Graph mailbox parser class
@author: Peeter Jyrviste
'''
import AbstractMailboxParser
import EmailGraph, time

class GraphParser(AbstractMailboxParser.AbstractMailboxParser):
    def __init__(self, mailbox, outputFile):
        self.mailbox = mailbox
        self.outputFile = outputFile
        self.graph = EmailGraph.EmailGraph(self.mailbox)
    
    def displayMail(self):
        self.graph.displayGraph()
    
    def pickleGraph(self):
        print 'Saving pickled graph to', self.outputFile
        print 'Please wait...'
        start = time.clock()
        EmailGraph.save(self.graph,self.outputFile)
        end = time.clock()
        print 'Email graph saved.'
        print "Time elapsed:", round(end - start, 3), "seconds"
    
    def test(self):
        nxgraph = self.graph.getNXGraph()
        print type(nxgraph)
        print '***'
        print self.graph.getEdgesByType('To')
        print '***'
        print self.graph.getEdgesByType('Attachment')
        print '***'
        print self.graph.getRoot()
        print '***'
        print self.graph.getNodeData('testing')
        print '***'
        for edge in nxgraph.edges():
            print edge
            print self.graph.getEdgeType(edge)
